Convert CSV (with a header row) to JSON rows
Converts CSV text to a JSON array of objects, using the first row as keys. Detects the delimiter and converts numbers/booleans automatically.
Request
POSThttps://data-tools.p.apihiver.com/v1/csv-to-json
JSON object. Required: csv.
Request Body
Edit the values below to test different scenarios.
Parameters and body structure are inherited from this endpoint's definition. Changes here only apply to this test run.
Language
Client
1curl --request POST \
2 --url https://data-tools.p.apihiver.com/v1/csv-to-json \
3 --header 'Accept: application/json' \
4 --header 'Content-Type: application/json' \
5 --header 'X-API-Key: YOUR_API_KEY' \
6 --data '{
7 "csv": "name,age\nAsha,30\nRavi,25"
8}'Convert CSV (with a header row) to JSON rows: Data Tools API reference
Converts CSV text to a JSON array of objects, using the first row as keys. Detects the delimiter and converts numbers/booleans automatically. This endpoint is part of the Data Tools API: Convert CSV ⇄ JSON, generate realistic fake test data (including Indian names and addresses), and create UUIDs in bulk.
Convert CSV (with a header row) to JSON rows: example requests in every language
POST /v1/csv-to-json in Shell (cURL)
curl --request POST \
--url https://data-tools.p.apihiver.com/v1/csv-to-json \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--header 'X-API-Key: YOUR_API_KEY' \
--data '{
"csv": "name,age\nAsha,30\nRavi,25"
}'POST /v1/csv-to-json in Shell (HTTPie)
echo '{
"csv": "name,age\nAsha,30\nRavi,25"
}' | \
http POST https://data-tools.p.apihiver.com/v1/csv-to-json \
Accept:application/json \
Content-Type:application/json \
X-API-Key:YOUR_API_KEYPOST /v1/csv-to-json in Shell (Wget)
wget --quiet \
--method POST \
--header 'Content-Type: application/json' \
--header 'Accept: application/json' \
--header 'X-API-Key: YOUR_API_KEY' \
--body-data '{\n "csv": "name,age\nAsha,30\nRavi,25"\n}' \
--output-document \
- https://data-tools.p.apihiver.com/v1/csv-to-jsonPOST /v1/csv-to-json in Node.js (http)
const http = require('https');
const options = {
method: 'POST',
hostname: 'data-tools.p.apihiver.com',
port: null,
path: '/v1/csv-to-json',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
}
};
const req = http.request(options, function (res) {
const chunks = [];
res.on('data', function (chunk) {
chunks.push(chunk);
});
res.on('end', function () {
const body = Buffer.concat(chunks);
console.log(body.toString());
});
});
req.write(JSON.stringify({csv: 'name,age\nAsha,30\nRavi,25'}));
req.end();POST /v1/csv-to-json in Node.js (Request)
const request = require('request');
const options = {
method: 'POST',
url: 'https://data-tools.p.apihiver.com/v1/csv-to-json',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
body: {csv: 'name,age\nAsha,30\nRavi,25'},
json: true
};
request(options, function (error, response, body) {
if (error) throw new Error(error);
console.log(body);
});POST /v1/csv-to-json in Node.js (Unirest)
const unirest = require('unirest');
const req = unirest('POST', 'https://data-tools.p.apihiver.com/v1/csv-to-json');
req.headers({
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
});
req.type('json');
req.send({
csv: 'name,age\nAsha,30\nRavi,25'
});
req.end(function (res) {
if (res.error) throw new Error(res.error);
console.log(res.body);
});POST /v1/csv-to-json in Node.js (Axios)
const axios = require('axios').default;
const options = {
method: 'POST',
url: 'https://data-tools.p.apihiver.com/v1/csv-to-json',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
data: {csv: 'name,age\nAsha,30\nRavi,25'}
};
try {
const { data } = await axios.request(options);
console.log(data);
} catch (error) {
console.error(error);
}POST /v1/csv-to-json in Node.js (Fetch)
const fetch = require('node-fetch');
const url = 'https://data-tools.p.apihiver.com/v1/csv-to-json';
const options = {
method: 'POST',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
body: '{"csv":"name,age\nAsha,30\nRavi,25"}'
};
try {
const response = await fetch(url, options);
const data = await response.json();
console.log(data);
} catch (error) {
console.error(error);
}POST /v1/csv-to-json in JavaScript (XMLHttpRequest)
const data = JSON.stringify({
csv: 'name,age\nAsha,30\nRavi,25'
});
const xhr = new XMLHttpRequest();
xhr.withCredentials = true;
xhr.addEventListener('readystatechange', function () {
if (this.readyState === this.DONE) {
console.log(this.responseText);
}
});
xhr.open('POST', 'https://data-tools.p.apihiver.com/v1/csv-to-json');
xhr.setRequestHeader('Content-Type', 'application/json');
xhr.setRequestHeader('Accept', 'application/json');
xhr.setRequestHeader('X-API-Key', 'YOUR_API_KEY');
xhr.send(data);POST /v1/csv-to-json in JavaScript (Axios)
import axios from 'axios';
const options = {
method: 'POST',
url: 'https://data-tools.p.apihiver.com/v1/csv-to-json',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
data: {csv: 'name,age\nAsha,30\nRavi,25'}
};
try {
const { data } = await axios.request(options);
console.log(data);
} catch (error) {
console.error(error);
}POST /v1/csv-to-json in JavaScript (Fetch)
const url = 'https://data-tools.p.apihiver.com/v1/csv-to-json';
const options = {
method: 'POST',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
body: '{"csv":"name,age\nAsha,30\nRavi,25"}'
};
try {
const response = await fetch(url, options);
const data = await response.json();
console.log(data);
} catch (error) {
console.error(error);
}POST /v1/csv-to-json in JavaScript (jQuery)
const settings = {
async: true,
crossDomain: true,
url: 'https://data-tools.p.apihiver.com/v1/csv-to-json',
method: 'POST',
headers: {
'Content-Type': 'application/json',
Accept: 'application/json',
'X-API-Key': 'YOUR_API_KEY'
},
processData: false,
data: '{\n "csv": "name,age\nAsha,30\nRavi,25"\n}'
};
$.ajax(settings).done(function (response) {
console.log(response);
});POST /v1/csv-to-json in Python (http.client)
import http.client
conn = http.client.HTTPSConnection("data-tools.p.apihiver.com")
payload = "{\n \"csv\": \"name,age\\nAsha,30\\nRavi,25\"\n}"
headers = {
'Content-Type': "application/json",
'Accept': "application/json",
'X-API-Key': "YOUR_API_KEY"
}
conn.request("POST", "/v1/csv-to-json", payload, headers)
res = conn.getresponse()
data = res.read()
print(data.decode("utf-8"))POST /v1/csv-to-json in Python (Requests)
import requests
url = "https://data-tools.p.apihiver.com/v1/csv-to-json"
payload = { "csv": "name,age
Asha,30
Ravi,25" }
headers = {
"Content-Type": "application/json",
"Accept": "application/json",
"X-API-Key": "YOUR_API_KEY"
}
response = requests.post(url, json=payload, headers=headers)
print(response.json())POST /v1/csv-to-json in PHP (cURL)

POST /v1/csv-to-json in Swift (NSURLSession)
import Foundation
let headers = [
"Content-Type": "application/json",
"Accept": "application/json",
"X-API-Key": "YOUR_API_KEY"
]
let parameters = ["csv": "name,age
Asha,30
Ravi,25"] as [String : Any]
let postData = JSONSerialization.data(withJSONObject: parameters, options: [])
let request = NSMutableURLRequest(url: NSURL(string: "https://data-tools.p.apihiver.com/v1/csv-to-json")! as URL,
cachePolicy: .useProtocolCachePolicy,
timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data
let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
if (error != nil) {
print(error as Any)
} else {
let httpResponse = response as? HTTPURLResponse
print(httpResponse)
}
})
dataTask.resume()POST /v1/csv-to-json in Objective-C (NSURLSession)
#import <Foundation/Foundation.h>
NSDictionary *headers = @{ @"Content-Type": @"application/json",
@"Accept": @"application/json",
@"X-API-Key": @"YOUR_API_KEY" };
NSDictionary *parameters = @{ @"csv": @"name,age
Asha,30
Ravi,25" };
NSData *postData = [NSJSONSerialization dataWithJSONObject:parameters options:0 error:nil];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:@"https://data-tools.p.apihiver.com/v1/csv-to-json"]
cachePolicy:NSURLRequestUseProtocolCachePolicy
timeoutInterval:10.0];
[request setHTTPMethod:@"POST"];
[request setAllHTTPHeaderFields:headers];
[request setHTTPBody:postData];
NSURLSession *session = [NSURLSession sharedSession];
NSURLSessionDataTask *dataTask = [session dataTaskWithRequest:request
completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
if (error) {
NSLog(@"%@", error);
} else {
NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *) response;
NSLog(@"%@", httpResponse);
}
}];
[dataTask resume];POST /v1/csv-to-json in Kotlin (OkHttp)
val client = OkHttpClient()
val mediaType = MediaType.parse("application/json")
val body = RequestBody.create(mediaType, "{\n \"csv\": \"name,age\\nAsha,30\\nRavi,25\"\n}")
val request = Request.Builder()
.url("https://data-tools.p.apihiver.com/v1/csv-to-json")
.post(body)
.addHeader("Content-Type", "application/json")
.addHeader("Accept", "application/json")
.addHeader("X-API-Key", "YOUR_API_KEY")
.build()
val response = client.newCall(request).execute()POST /v1/csv-to-json in C (libcurl)
CURL *hnd = curl_easy_init();
curl_easy_setopt(hnd, CURLOPT_CUSTOMREQUEST, "POST");
curl_easy_setopt(hnd, CURLOPT_URL, "https://data-tools.p.apihiver.com/v1/csv-to-json");
struct curl_slist *headers = NULL;
headers = curl_slist_append(headers, "Content-Type: application/json");
headers = curl_slist_append(headers, "Accept: application/json");
headers = curl_slist_append(headers, "X-API-Key: YOUR_API_KEY");
curl_easy_setopt(hnd, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(hnd, CURLOPT_POSTFIELDS, "{\n \"csv\": \"name,age\\nAsha,30\\nRavi,25\"\n}");
CURLcode ret = curl_easy_perform(hnd);POST /v1/csv-to-json in Clojure (clj-http)
(require '[clj-http.client :as client])
(client/post "https://data-tools.p.apihiver.com/v1/csv-to-json" {:headers {:X-API-Key "YOUR_API_KEY"}
:content-type :json
:form-params {:csv "name,age
Asha,30
Ravi,25"}
:accept :json})POST /v1/csv-to-json in OCaml (CoHTTP)
open Cohttp_lwt_unix
open Cohttp
open Lwt
let uri = Uri.of_string "https://data-tools.p.apihiver.com/v1/csv-to-json" in
let headers = Header.add_list (Header.init ()) [
("Content-Type", "application/json");
("Accept", "application/json");
("X-API-Key", "YOUR_API_KEY");
] in
let body = Cohttp_lwt_body.of_string "{\n \"csv\": \"name,age\\nAsha,30\\nRavi,25\"\n}" in
Client.call ~headers ~body `POST uri
>>= fun (res, body_stream) ->
(* Do stuff with the result *)POST /v1/csv-to-json in R (httr)
library(httr)
url <- "https://data-tools.p.apihiver.com/v1/csv-to-json"
payload <- "{\n \"csv\": \"name,age\\nAsha,30\\nRavi,25\"\n}"
encode <- "json"
response <- VERB("POST", url, body = payload, add_headers('X-API-Key' = 'YOUR_API_KEY'), content_type("application/json"), accept("application/json"), encode = encode)
content(response, "text")POST /v1/csv-to-json in PowerShell (Invoke-WebRequest)
$headers=@{}
$headers.Add("Content-Type", "application/json")
$headers.Add("Accept", "application/json")
$headers.Add("X-API-Key", "YOUR_API_KEY")
$response = Invoke-WebRequest -Uri 'https://data-tools.p.apihiver.com/v1/csv-to-json' -Method POST -Headers $headers -ContentType 'application/json' -Body '{
"csv": "name,age\nAsha,30\nRavi,25"
}'POST /v1/csv-to-json in PowerShell (Invoke-RestMethod)
$headers=@{}
$headers.Add("Content-Type", "application/json")
$headers.Add("Accept", "application/json")
$headers.Add("X-API-Key", "YOUR_API_KEY")
$response = Invoke-RestMethod -Uri 'https://data-tools.p.apihiver.com/v1/csv-to-json' -Method POST -Headers $headers -ContentType 'application/json' -Body '{
"csv": "name,age\nAsha,30\nRavi,25"
}'POST /v1/csv-to-json in HTTP (HTTP/1.1)
POST /v1/csv-to-json HTTP/1.1
Content-Type: application/json
Accept: application/json
X-Api-Key: YOUR_API_KEY
Host: data-tools.p.apihiver.com
Content-Length: 41
{
"csv": "name,age\nAsha,30\nRavi,25"
}Example response (200, application/json)
Success.
1{
2 "rows": [
3 {
4 "age": 30,
5 "name": "Asha"
6 },
7 {
8 "age": 25,
9 "name": "Ravi"
10 }
11 ],
12 "columns": [
13 "name",
14 "age"
15 ],
16 "delimiter": ",",
17 "row_count": 2
18}Errors
- 400 — A required parameter is missing or a value has the wrong format.
1{ 2 "error": { 3 "code": "INVALID_INPUT", 4 "message": "csv: Field required" 5 } 6}
Gateway errors (missing key, no subscription, rate limits) are listed in Error codes.